



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Swift 里 Dictionary</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Swift 里 Dictionary</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 17:56:30 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<blockquote><p><code>Dictionary</code> uses two storage schemes: native storage and Cocoa storage.</p></blockquote>
<p>只看 native storage 的，也就是和 OC 无关的。</p>
<h2>类图</h2>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/669116/201903/669116-20190324135700149-1994157014.jpg" />￼</p>
<h2>内存分布</h2>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/669116/201903/669116-20190324135701007-1772190660.jpg" />￼</p>
<p>分配内存的地方：</p>
<pre class="prettyprint linenums"><code>  static internal func allocate(<br />
    scale: Int8,<br />
    age: Int32?,<br />
    seed: Int?<br />
  ) -&gt; _DictionaryStorage {<br />
    // The entry count must be representable by an Int value; hence the scale&#039;s<br />
    // peculiar upper bound.<br />
    _internalInvariant(scale &gt;= 0 &amp;&amp; scale &lt; Int.bitWidth - 1)

    let bucketCount = (1 as Int) &amp;&lt;&lt; scale<br />
    let wordCount = _UnsafeBitset.wordCount(forCapacity: bucketCount)<br />
    let storage = Builtin.allocWithTailElems_3(<br />
      _DictionaryStorage&lt;Key, Value&gt;.self,<br />
      wordCount._builtinWordValue, _HashTable.Word.self,<br />
      bucketCount._builtinWordValue, Key.self,<br />
      bucketCount._builtinWordValue, Value.self)

    let metadataAddr = Builtin.projectTailElems(storage, _HashTable.Word.self)<br />
    let keysAddr = Builtin.getTailAddr_Word(<br />
      metadataAddr, wordCount._builtinWordValue, _HashTable.Word.self,<br />
      Key.self)<br />
    let valuesAddr = Builtin.getTailAddr_Word(<br />
      keysAddr, bucketCount._builtinWordValue, Key.self,<br />
      Value.self)<br />
    storage._count = 0<br />
    storage._capacity = _HashTable.capacity(forScale: scale)<br />
    storage._scale = scale<br />
    storage._reservedScale = 0<br />
    storage._extra = 0

    if let age = age {<br />
      storage._age = age<br />
    } else {<br />
      // The default mutation count is simply a scrambled version of the storage<br />
      // address.<br />
      storage._age = Int32(<br />
        truncatingIfNeeded: ObjectIdentifier(storage).hashValue)<br />
    }

    storage._seed = seed ?? _HashTable.hashSeed(for: storage, scale: scale)<br />
    storage._rawKeys = UnsafeMutableRawPointer(keysAddr)<br />
    storage._rawValues = UnsafeMutableRawPointer(valuesAddr)

    // Initialize hash table metadata.<br />
    storage._hashTable.clear()<br />
    return storage<br />
  }

</code></pre>
<h2>和 Set 区别</h2>
<p>区别仅仅在于<code>storage</code>尾部有两个数组，一个存储<code>key</code>，一个存储<code>value</code>。<br />
进行各种操作时，要同时操作<code>key</code>和<code>value</code>。</p>
<pre class="prettyprint linenums"><code>  @inlinable // FIXME(inline-always) was usableFromInline<br />
  @inline(__always)<br />
  internal func uncheckedInitialize(<br />
    at bucket: Bucket,<br />
    toKey key: __owned Key,<br />
    value: __owned Value) {<br />
    defer { _fixLifetime(self) }<br />
    _internalInvariant(hashTable.isValid(bucket))<br />
    (_keys + bucket.offset).initialize(to: key)<br />
    (_values + bucket.offset).initialize(to: value)<br />
  }<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqve2no9.html">基本排序算法&mdash;&mdash;插入排序java实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rkp4mq.html">Gym 101102C---Bored Judge（区间最大值）</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m7y508.html">SQL升级脚本实现按版本差异化升级</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q75o2g9.html">input自动获取焦点</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xlo1g9.html">wampserver修改mysql密码后phpmyadmin登陆错误处理方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okznyp9.html">nginx搭建flv、mp4流媒体服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyen4k9.html">POJ 2455 网络流 基础题 二分&plus;网络流 dicnic 以及 sap算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zd7g19.html">Java 标准DBUtil 写法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd7wkd9.html">Map中的entrySet&lpar;&rpar;&semi;跟keySet&lpar;&rpar;&semi;的区别是什么</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdv1649.html">希尔排序（Go语言）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96prw7v8.html">AI - 深度学习之美十四章-概念摘要（8~14）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1vep5q.html">Day19-File操作-创建 删除，文件过滤</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj21479.html">语法的二义性和token的超前扫描</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gnnrzq.html">chrome 远程调试相关问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/960k7xn9.html">zabbix微信预警出现的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25ld0oq.html">java框架常见的面试题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn5vomq.html">深入理解Linux内核－页高速缓存</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7elr5g9.html">STL&lowbar;std&colon;&colon;iterator</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pne73q.html">Java设计原则之依赖倒转原则</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnngrexq.html">《You dont know JS》原生函数</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv23ex19.html">springboot注解大全</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw2my78.html">JAVA结合testng断言verify&lpar;断言失败不中断继续执行&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wgd5wq.html">vue踩坑&lpar;一&rpar;&colon;打包上线</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw23mz8.html">688&period; Knight Probability in Chessboard棋子留在棋盘上的概率</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2ryo6q.html">Fabric的权限管理：Attribute-Based Access Control</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllpxj6q.html">Python3实战系列之五（获取印度售后数据项目）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv4xzr8.html">memmove、memcpy和memccpy简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4r27z9.html">SAS语言结构</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4j3we5q.html">SGTtrick</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllp22kq.html">python   repr&lpar;&rpar;和str&lpar;&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
